IMPLEMENTATION MODULE LOWFILES;   (* TopSpeed Modula-2 *)

FROM FIO IMPORT File, IOresult, Seek, RdBin, WrBin, Close, Create,
                Open, Size, IOcheck;

FROM Storage IMPORT ALLOCATE, DEALLOCATE;

TYPE LowFile = POINTER TO File;

PROCEDURE ResetLowFile(VAR f : LowFile; NAME : ARRAY OF CHAR;
                       VAR IO : INTEGER);
  BEGIN
    ALLOCATE(f,SIZE(f^));
    f^:=Open(NAME);
    IO:=INTEGER(IOresult())
  END ResetLowFile;

PROCEDURE RewriteLowFile(VAR f : LowFile; NAME : ARRAY OF CHAR;
                         VAR IO : INTEGER);
  BEGIN
    ALLOCATE(f,SIZE(f^));
    f^:=Create(NAME);
    IO:=INTEGER(IOresult())
  END RewriteLowFile;

PROCEDURE CloseLowFile(VAR f : LowFile; VAR IO : INTEGER);
  BEGIN
    Close(f^); IO:=INTEGER(IOresult());
    DEALLOCATE(f,SIZE(f^))
  END CloseLowFile;

PROCEDURE WriteNBytes(VAR f : LowFile; ab: FilePos; n : CARDINAL;
                      VAR V : ARRAY OF BYTE;
                      VAR IO : INTEGER);
  BEGIN
    Seek(f^,ab); IO:=INTEGER(IOresult());
    IF IO=0 THEN
      WrBin(f^,V,n);
      IO:=INTEGER(IOresult())
    END (* IF *)
  END WriteNBytes;

PROCEDURE ReadNBytes(VAR f : LowFile; ab: FilePos; n : CARDINAL;
                     VAR V : ARRAY OF BYTE;
                     VAR IO : INTEGER);
  BEGIN
    Seek(f^,ab); IO:=INTEGER(IOresult());
    IF IO=0 THEN
      n:=RdBin(f^,V,n);
      IO:=INTEGER(IOresult())
    END (* IF *)
  END ReadNBytes;

PROCEDURE LowFileSize(VAR f : LowFile; VAR IO : INTEGER) : FilePos;
  BEGIN
    RETURN Size(f^)
  END LowFileSize;

BEGIN
  IOcheck:=FALSE
END LOWFILES.
