IMPLEMENTATION MODULE IBMKbd;
(* $L+ *)

(* *********************************************************** )
(                                                              )
(   Jrg Hopfe, Bahnhofstr.1, 3012 Langenhagen                 )
(   Begonnen am: 21.11.89                                      )
(   Letzte nderung: siehe Dateidatum                          )
(   Compiler: Fitted Modula-2 v2.0                             )
(                                                              )
( *********************************************************** *)

FROM SYSTEM IMPORT ASSEMBLER,BYTE;

CONST
  (* Bitmasken fr Tataturstatus *)
  RShiftMask     = 01H;
  LShiftMask     = 02H;
  ShiftMask      = 03H;
  CtrlMask       = 04H;
  AltMask        = 08H;
  AltCtrlMask    = 0CH;
  ScrollMask     = 10H;
  NumMask        = 20H;
  CapsLockMask   = 40H;
  InsMask        = 80H;


VAR
  KbdFunkNum:BYTE;

PROCEDURE WaitKey(VAR Taste,Shift:CARDINAL);
  BEGIN
    ASM
      MOV AH,0H     (* Funktion 0H Lese Taste, warte wenn keine im Puffer *)
      ADD AH,[KbdFunkNum] (* + 10H bei AT's fr erweiterten Code *)
      INT 16H        (* Tastatur Interrupt OUT: Scancode in AX *)
      CMP AL,0DH     (* Ist es Return? *)
      JZ  NewCode
      CMP AL,1BH     (* Oder Esc ? *)
      JZ  NewCode
      CMP AL,09H     (* Oder Tab ? *)
      JZ NewCode
      CMP AL,08H     (* Oder BackSpace ? *)
      JZ NewCode
      JMP Weiter
    NewCode:
      XCHG AL,AH     (* Code nach AH *)
      XOR AL,AL      (* LowByte = 0 *)
    Weiter:
      LES DI,Taste   (* Adresse des VAR-Parametes nach ES:DI *)
      STOSW          (* ScanCode bergeben *)
      MOV AH,02      (* Funktion lese Tastaturstatus *)
      ADD AH,[KbdFunkNum] (* + 10H bei AT's fr erweiterten Code *)
      INT 16H        (* OUT: Status in AL *)
      LES DI,Shift   (* Adresse des VAR-Parametes nach ES:DI *)
      STOSW          (* Wert bergeben *)
    END;
  END WaitKey;

PROCEDURE SearchKey(VAR Taste,Shift:CARDINAL):BOOLEAN;
  VAR Erg:BOOLEAN;
  BEGIN
    ASM
      MOV AH,01H        (* Funktion teste auf Taste. Hol sie, wenn vorhanden *)
      ADD AH,[KbdFunkNum] (* + 10H bei AT's fr erweiterten Code *)
      INT 16H           (* Out:Scancode in AX *)
      JZ NoKey          (* Z=1 -> Keine Taste da *)
      LES DI,Taste      (* Adresse des VAR-Parametes nach ES:DI *)
      STOSW             (* ScanCode bergeben *)
      MOV AH,02         (* Funktion lies Status *)
      ADD AH,[KbdFunkNum] (* + 10H bei AT's fr erweiterten Code *)
      INT 16H           (* OUT: Status i AL *)
      XOR AH,AH         (* HiByte lschen *)
      LES DI,Shift      (* Adresse des VAR-Parametes nach ES:DI *)
      STOSW             (* Wert bergeben *)
      MOV [Erg],TRUE    (* Erfolg melden *)
      JMP Out           (* Fertig *)

    NoKey:
      MOV [Erg],FALSE   (* Fehlschlag melden *)
    Out:
    END;
    RETURN Erg;
  END SearchKey;

PROCEDURE BitAND(Wert,Maske:CARDINAL):CARDINAL;
  VAR Trans:CARDINAL;
  BEGIN
    ASM
      MOV AX,[Wert]
      AND AX,[Maske]
      MOV [Trans],AX
    END;
    RETURN Trans;
  END BitAND;

PROCEDURE BitOR(Wert,Maske:CARDINAL):CARDINAL;
  VAR Trans:CARDINAL;
  BEGIN
    ASM
      MOV AX,[Wert]
      OR  AX,[Maske]
      MOV [Trans],AX
    END;
    RETURN Trans;
  END BitOR;

PROCEDURE TestBit(Wert,Maske:CARDINAL):CARDINAL;
  VAR Erg:CARDINAL;
  BEGIN
    ASM
      MOV AX,[Wert]    (* Zu testenden Wert holen *)
      AND AX,[Maske]   (* Mit Maske verknpfen    *)
      MOV [Erg],AX     (* Ergenbis fr Modula bereitstellen *)
    END;
    RETURN Erg;
  END TestBit;


PROCEDURE LShift(Shift:CARDINAL):BOOLEAN;
  BEGIN
    RETURN BitAND(Shift,LShiftMask)=LShiftMask;
  END LShift;

PROCEDURE RShift(Shift:CARDINAL):BOOLEAN;
  BEGIN
    RETURN BitAND(Shift,RShiftMask)=RShiftMask;
  END RShift;

PROCEDURE Shift(Shift:CARDINAL):BOOLEAN;
  BEGIN
    RETURN (LShift(Shift) OR RShift(Shift));
  END Shift;

PROCEDURE Ctrl(Shift:CARDINAL):BOOLEAN;
  BEGIN
    RETURN BitAND(Shift,CtrlMask)=CtrlMask;
  END Ctrl;

PROCEDURE Alt(Shift:CARDINAL):BOOLEAN;
  BEGIN
    RETURN BitAND(Shift,AltMask)=AltMask;
  END Alt;


(* AltGr und CtrlAlt unterscheiden sich nicht im normalen Flagset,
   (dort haben sie beide den Wert 04H + 08H)
   deshalb mu zu ihrer Differenzierung in weiteren von der INT09 ISR
   verwalteten Flagsets nachgesehen werden. *)

PROCEDURE AltGr(Shift:CARDINAL):BOOLEAN;
  CONST Kbd_Flag3 = 96H; (* Bit 4 des Bytes 40H:96H gibt an, ob die
                            AltGr-Taste gedrckt ist. *)
        AltGrMask = 10H;
  BEGIN
    ASM
      MOV AX,40H
      MOV ES,AX                  (* ES zeigt auf BIOS-Datensegment *)
      MOV AL,ES:[Kbd_Flag3]      (* Flagset holen *)
      MOV [Shift],AL             (* Wertparameter 'mibrauchen' *)
    END;
    RETURN TestBit(Shift,AltGrMask)=AltGrMask;
  END AltGr;

PROCEDURE AltCtrl(Shift:CARDINAL):BOOLEAN;
  BEGIN
    IF NOT AltGr(Shift) THEN
      RETURN BitAND(Shift,AltCtrlMask)=AltCtrlMask;
    ELSE
      RETURN FALSE;
    END;
  END AltCtrl;


PROCEDURE InsSet(Shift:CARDINAL):BOOLEAN;
  BEGIN
    RETURN TestBit(Shift,InsMask)=InsMask;
  END InsSet;

PROCEDURE NumLock(Shift:CARDINAL):BOOLEAN;
  BEGIN
    RETURN TestBit(Shift,NumMask)=NumMask;
  END NumLock;

PROCEDURE CapsLock(Shift:CARDINAL):BOOLEAN;
  BEGIN
    RETURN TestBit(Shift,CapsLockMask)=CapsLockMask;
  END CapsLock;

PROCEDURE ScrollLock(Shift:CARDINAL):BOOLEAN;
  BEGIN
    RETURN TestBit(Shift,ScrollMask)=ScrollMask;
  END ScrollLock;

PROCEDURE ASCII(ScanCode:CARDINAL):CHAR;
  (* Holt das LowByte des Scancodes als CHAR *)
  VAR Trans:CHAR;
  BEGIN
    ASM
      MOV AL,BYTE [ScanCode]
      MOV [Trans],AL
    END;
    RETURN Trans;
  END ASCII;

BEGIN
  ASM
    PUSH DS
    MOV AX,0FFFFH              (* Segmentadresse ROM-BIOS *)
    MOV DS,AX
    MOV AL,[0EH]              (* Hier steht der Gertetyp FC = AT, FE = XT/PC
                                 FF = PC *)
    POP DS
    CMP AL,0FCH                (* Ist es ein AT ? *)
    JNZ IsXT
    MOV KbdFunkNum, 10H        (* Addent fr erweiterte Funktionen *)
    JMP Fertig
IsXT:
    MOV KbdFunkNum,0H          (* Keine Vernderung fr normale Funktionen *)
Fertig:
  END; (* ASM *)
END IBMKbd.