(* (c) Jrg Hopfe 1989/90
   geschrieben in FST-Modula-2 v2.0
*)
IMPLEMENTATION MODULE ScreenLo[7];
(* 7= Niedrige Prioritt vgl. FST-dt.Handbuch S.26  4.10 *)

(* $L+ *) (* Zeilennummern fr Debugging *)

FROM SYSTEM              IMPORT WORD,ADDRESS,SEG,OFS,ASSEMBLER;
FROM System              IMPORT Move;
FROM NumberConversion    IMPORT CardToString,IntToString;
FROM Storage             IMPORT Available,ALLOCATE,DEALLOCATE;
IMPORT Debug;
IMPORT System;
TYPE  ScreenBlockTyp = POINTER TO ScreenBlock;

ScreenBlock          = RECORD
                         BufSize,
                         XPos,YPos,
                         Breite,
                         Hoehe:CARDINAL;
                         Buf:ADDRESS;
                       END;

VAR
  ScreenBase      : CARDINAL;           (* Startsegement des VIODEO-RAM    *)

  BytesPerChar    : CARDINAL;           (* Bytes/Zeichen im VideoRam *)
  LastCurLine     : CARDINAL;           (* letzte Cursorzeile CGA:8,HGC:16 *)

  FramePutted     : BOOLEAN;            (* XORFrame auf Schirm?            *)
  FrameXOben,FrameYOben,
  FrameXUnten,FrameYUnten :CARDINAL;    (* Die Abmessungen                 *)
  FrameBufAllocated:BOOLEAN;            (* Schirmpuffer angelegt ?         *)
  SavedScreen    : ADDRESS;             (* Puffer fr Schirminhalt         *)

(* ------------------- Bildschirmausgabe --------------------------------- *)

PROCEDURE PrintString(XPos,YPos,Attribut:CARDINAL; VAR String:ARRAY OF CHAR);
  BEGIN
    ASM (* Assembler einschalten *)
                PUSH    DS                      (* Wird verwendet  *)
                MOV     AX,ScreenBase           (* Start Video-Ram *)
                MOV     ES,AX                   (* Nach ES         *)

                MOV     AX,[YPos]               (* Zeile holen     *)
                DEC     AX                      (* Logisch 1 = phys. 0 *)
                MOV     BX,[ScreenCols]         (* Anzahl der Spalten/Zeile *)
                MUL     BX                      (* AX=AX*BX *)

                MOV     BX,[XPos]               (* Spalte nach BX *)
                DEC     BX                      (* Logisch in physisch *)
                ADD     AX,BX                   (* AX=Offset im VideoSegemnt *)
                SHL     AX,1                    (* AX*2 weil 2 Byte/Zeichen *)
                MOV     DI,AX                   (* ES:DI=Zeiger in Video-Ram *)

                MOV     CX,[BP+0AH]             (* Obergrenze String holen *)
                INC     CX                      (* CX=Max.Lnge *)

                MOV     AH,[Attribut]           (* AttributByte nach AH *)
                LDS     SI,String               (* StringAdresse nach DS.SI *)

                CLD                             (* Aufwrts bitte ! *)
      OutLoop:
                LODSB                           (* Ein Zeichen nach AL *)
                OR      AL,AL                   (* Ist es Null? *)
                JZ      OutEnde                 (* Dann Schlu *)
                STOSW                           (* AX in den Bildschrim *)
                LOOP    OutLoop                 (* Nchstes Zeichen *)

       OutEnde:

                POP     DS                      (* DS restaurieren *)
     END (* asm *)
  END PrintString;


PROCEDURE PrintPartOfString(XPos,YPos,Attribut:CARDINAL;
                            VAR Text:ARRAY OF CHAR; Start,Count:CARDINAL);
  BEGIN
    ASM (* Assembler einschalten *)
                PUSH    DS                      (* Wird verwendet  *)
                MOV     AX,ScreenBase           (* Start Video-Ram *)
                MOV     ES,AX                   (* Nach ES         *)

                MOV     AX,[YPos]               (* Zeile holen     *)
                DEC     AX                      (* Logisch 1 = phys. 0 *)
                MOV     BX,[ScreenCols]         (* Anzahl der Spalten/Zeile *)
                MUL     BX                      (* AX=AX*BX *)
                MOV     BX,[XPos]               (* Spalte nach BX *)
                DEC     BX                      (* Logisch in physisch *)
                ADD     AX,BX                   (* AX=Offset im VideoSegemnt *)
                SHL     AX,1                    (* AX*2 weil 2 Byte/Zeichen *)
                MOV     DI,AX                   (* ES:DI=Zeiger in Video-Ram *)

                MOV     CX,[Count]              (* Ausgabelnge *)
                JCXZ    OutEnde                 (* Keine Null-Strings bitte! *)
                MOV     AH,[Attribut]           (* AttributByte nach AH *)
                LDS     SI,[Text]               (* StringAdresse nach DS.SI *)
                ADD     SI,[Start]              (* StingAnfang+Start *)
                DEC     SI                      (* -1 = Offset 1tes Zeichen *)

                CLD                             (* Aufwrts bitte ! *)
      OutLoop:
                LODSB                           (* Ein Zeichen nach AL *)
                STOSW                           (* AX in den Bildschrim *)
                LOOP    OutLoop                 (* Nchstes Zeichen *)

       OutEnde:

                POP     DS                      (* DS restaurieren *)
     END (* asm *)
  END PrintPartOfString;



PROCEDURE PrintCard(XPos,YPos,Attribut:CARDINAL;
                    Number:CARDINAL; Width:CARDINAL);
  VAR  DummyStr:ARRAY[0..132] OF CHAR;
  BEGIN
    CardToString(Number,DummyStr,Width);
    PrintString(XPos,YPos,Attribut,DummyStr);
  END PrintCard;

PROCEDURE PrintInt(XPos,YPos,Attribut:CARDINAL;
                   Number:INTEGER; Width:CARDINAL);
  VAR  DummyStr:ARRAY[0..132] OF CHAR;
  BEGIN
    IntToString(Number,DummyStr,Width);
    PrintString(XPos,YPos,Attribut,DummyStr);
  END PrintInt;

PROCEDURE PrintBool(XPos,YPos,Attribut:CARDINAL; Wert:BOOLEAN);
  VAR DummyStr:ARRAY[0..5] OF CHAR;
  BEGIN
    IF Wert=TRUE THEN
      DummyStr:=' TRUE'
      ELSE DummyStr:='FALSE'
    END;
    PrintString(XPos,YPos,Attribut,DummyStr);
  END PrintBool;

(* --------------------- Basisroutinen fr Fenstermodule ------------------- *)

PROCEDURE MoveScreenBlock(VAR BufPtr:ScreenBlockTyp; Direction:DirectionTyp);
  VAR ScreenPtr    :ADDRESS;
      TempPtr      :ADDRESS;
      ScX,ScY     :CARDINAL;
      ScreenDelta,
      BufDelta     :CARDINAL;
      Count,Lauf   :CARDINAL;

  BEGIN
    WITH BufPtr^  DO
      ScX:=XPos;
      ScY:=YPos;
      BufDelta:=BytesPerChar * Breite;
      Count:=Hoehe;
      TempPtr := Buf;
      ScreenPtr.SEG:=ScreenBase;
      ScreenPtr.OFS:=((ScY-1) * ScreenCols + (ScX-1)) * BytesPerChar;
      ScreenDelta:= ScreenCols * BytesPerChar;
    END;

    FOR Lauf:=1 TO Count DO
      IF (Direction = BufToScreen) THEN
        Move(TempPtr,ScreenPtr,BufDelta);
      ELSE
        Move(ScreenPtr,TempPtr,BufDelta);
      END;
      INC(TempPtr.OFS,BufDelta);
      INC(ScreenPtr.OFS,ScreenDelta);
    END (* for *)

    (*
    ASM
      PUSH DS
      MOV CX,Count
      JCXZ Out
      CLD
      MOV DX,[ScreenDelta]

      CMP [Direction],BufToScreen
      JNZ Store

      MOV AX,[ScreenBase]
      MOV ES,AX
      MOV DI,[ScreenOfs]
      LDS SI,[TempPtr]
    Loop1:
      PUSH CX
      MOV CX,[BufDelta]
      REP MOVSW
      ADD DI,DX
      POP CX
      LOOP Loop1
      JMP Out

    Store:
      MOV AX,[ScreenBase]
      MOV DS,AX
      MOV SI,ScreenOfs
      LES DI,[TempPtr]
    Loop2:
      PUSH CX
      MOV CX,[BufDelta]
      REP MOVSW
      ADD SI,DX
      POP CX
      LOOP Loop2
    Out:
      POP DS
    END;
*)
  END MoveScreenBlock;


PROCEDURE AllocBuf_ForScreenBlock(VAR Handle:ScreenBlockTyp;
                                  StartX,StartY:CARDINAL;
                                  EndX,EndY:CARDINAL
                                  ):BOOLEAN;
  BEGIN
    IF Available(SIZE(ScreenBlock)) THEN
      ALLOCATE(Handle,SIZE(ScreenBlock));
      WITH Handle^ DO
        XPos:=StartX;
        YPos:=StartY;
        Breite:=EndX-StartX+1;
        Hoehe:=EndY-StartY+1;
        BufSize:= (Breite * BytesPerChar) * Hoehe;
        IF Available(BufSize) THEN
          ALLOCATE(Buf,BufSize);
        ELSE
          DEALLOCATE(Handle,SIZE(Handle));
          Handle:=NIL;
          RETURN FALSE;
        END; (* else *)
      END;
      RETURN (TRUE);
    ELSE
      RETURN (FALSE);
    END;
  END AllocBuf_ForScreenBlock;


PROCEDURE FreeBuf_ForScreenBlock(VAR Handle:ScreenBlockTyp);
  BEGIN
    IF Handle<>NIL THEN
      DEALLOCATE(Handle^.Buf,Handle^.BufSize);
      DEALLOCATE(Handle,SIZE(ScreenBlock));
      Handle:=NIL;
    END;
  END FreeBuf_ForScreenBlock;


PROCEDURE SetBufs_ScreenPos(VAR Handle:ScreenBlockTyp; NewXPos,NewYPos:CARDINAL);
  BEGIN
    IF Handle <> NIL THEN
      Handle^.XPos:=NewXPos;
      Handle^.YPos:=NewYPos;
    END;
  END SetBufs_ScreenPos;


(* --------------- Scrollen,Leeren und Fllen von Schirmbereichen ----------- *)

PROCEDURE DoTheScroll(Up:BOOLEAN;
                      Lines,XLeft,YTop,XRight,YBottom,FillAttr:CARDINAL);
  VAR SpaceString:ARRAY[0..256] OF CHAR;
      Lauf:CARDINAL;
  BEGIN
    IF YTop=YBottom THEN
      SpaceString:='';
      FOR Lauf:= 0 TO XRight-XLeft DO
        SpaceString[Lauf]:=' ';
      END;
      SpaceString[XRight-XLeft+1] := 0C;
      PrintString(XLeft,YTop,FillAttr,SpaceString);
    ELSE
      ASM
               MOV AH,7              (* Funktion 7 = ScrollDown *)
               CMP [Up],TRUE
               JNZ DoDown
               DEC AH                (* Funktion 6 = ScrollUp *)
      DoDown:
               MOV AL,BYTE [Lines ]  (* Anzahl der Zeilen *)

               MOV CL,BYTE  [XLeft]
               DEC CL                (* LowByte von XLeft - 1 = Erste Spalte *)

               MOV CH,BYTE  [YTop]
               DEC CH                (* Dito fr erste Zeile *)

               MOV DL,BYTE  [XRight]
               DEC DL

               MOV DH,BYTE  [YBottom]
               DEC DH

               MOV BH,BYTE  [FillAttr] (* Attribut nach BH *)
               INT 10H                    (* BIOS-VideoInterrupt *)
      END; (* asm *)
    END; (* else *)
  END DoTheScroll;


PROCEDURE ScrollScreenArea(Up:BOOLEAN;
                           XLeft,YTop,XRight,YBottom,FillAttr:CARDINAL);
  BEGIN
    DoTheScroll(Up,1,XLeft,YTop,XRight,YBottom,FillAttr);
  END ScrollScreenArea;


PROCEDURE ClearScreenArea(XLeft,YTop,XRight,YBottom,FillAttr:CARDINAL);
  BEGIN
    DoTheScroll(TRUE,0,XLeft,YTop,XRight,YBottom,FillAttr);
  END ClearScreenArea;


PROCEDURE FloodScreenArea(XLeft,YTop,XRight,YBottom,FloodAttr:CARDINAL; FloodChar:CHAR);
  VAR Lauf:CARDINAL; FloodString:ARRAY[0..256] OF CHAR;
  BEGIN
    FOR Lauf := 0 TO (XRight-XLeft) DO
      FloodString[Lauf]:=FloodChar;
    END;
    FloodString[XRight-XLeft+1]:=0C;
    FOR Lauf:=YTop TO YBottom DO
      PrintString(XLeft,Lauf,FloodAttr,FloodString);
    END;
  END FloodScreenArea;


(* --------------------- Hardware Cursor positionieren ------------------- *)

PROCEDURE SetCursor(XPos,YPos:CARDINAL);
  BEGIN
    ASM
      MOV DH,BYTE [YPos]
      DEC DH
      MOV DL,BYTE [XPos]
      DEC DL
      MOV AX,40H
      MOV ES,AX
      MOV BH,ES:[62H] (* BIOS-Var. Aktuelle Bildschirmseite *)
      MOV AH,2H      (* Funktion 2 Positioniere Cursor *)
      INT 10H        (* VideoInterrupt *)
    END;
  END SetCursor;




PROCEDURE SetRahmen(XO,YO,XU,YU:CARDINAL; Buf:ADDRESS; On:BOOLEAN);
CONST
  LO= '';
  RO ='';
  LU ='';
  RU ='';
  Gerade ='';
  Hoch   ='';

  VAR ScrMerk:ADDRESS;

  BEGIN
    ASM
(*-------------------------------------------------- *)
              PUSH      DS                       (* Wird immer zerstrt! *)

(* Pointer in den Bildschirm fr Ecke links oben errechnen und merken *)
              MOV       AX,YO                    (* ZeilenNr. *)
              DEC       AX                       (* Log ab 1 phys ab 0 *)
              MUL       ScreenCols               (* Mal SpaltenZahl *)

              ADD       AX,XO                    (* + Spaltenversatz *)
              DEC       AX                       (* Log -> Phys *)
              SHL       AX,1                     (* 2 Byte / Zeichen *)
              MOV       WORD     ScrMerk,AX      (* Offset auf Stack *)
              MOV       AX,ScreenBase            (* Segment auf Stack *)
              MOV       WORD     ScrMerk+2,AX

(* Addent fr Differenz zwischen zwei Zeichen untereinander vorbereiten *)
              MOV       DX,ScreenCols            (* Addent vorbereiten *)
              DEC       DX                       (* ScreenCols-1 *)
              SHL       DX,1                     (* * 2 = Addent *)

(* Was soll geschehen ? *)
              CMP      On,0                      (* On=0 heisst Rahmen weg *)
              JNZ      DoOn                      (* Nein dann Zeichnen *)
              JMP      DoOff                     (* Sonst entfernen *)

DoOn:
(* Zeiger auf Buf und Screen vorbereiten *)
              MOV       AH,InversAttr            (* Attribut nach AH *)

              LDS       SI,ScrMerk               (* Zeiger in Video-RAM *)
              LES       DI,Buf                   (* Zeiger auf Puffer *)

(*  Linke Obere Ecke setzen *)
              MOV       AL,LO                    (* Symbol nach AL *)
              MOVSW                              (* ScreenByte in Puffer *)
              MOV       [SI+0FFFEH],AX                (* AX in Video-RAM *)

(* Rest der oberen Zeile setzen *)
              MOV       CX,XU                    (* Endwert *)
              SUB       CX,XO                    (* Minus Anfangswert *)
              DEC       CX                       (* Minus 1 = StrichLnge *)
              PUSH      CX                       (* Wird nochmal gebraucht! *)
              MOV       AL,Gerade                (* Zeichen nach AL *)

Loop1:
              MOVSW                              (* Screen sichern *)
              MOV       [SI+0FFFEH],AX                (* Zeichen schreiben *)
              LOOP      Loop1                  (* und weiter *)

(* Rechte obere Ecke Schreiben *)
              MOV       AL,RO                    (* Symbol nach AL *)
              MOVSW
              MOV       [SI+0FFFEH],AX                (* und Schreiben *)

(* Rechte Seite Schreiben *)
              MOV       CX,YU                    (* Unten *)
              SUB       CX,YO                    (* - Oben *)
              DEC       CX                       (* - 1 = Hhe *)
              PUSH      CX                       (* Brauchen wir nochmal! *)

              MOV       AL,Hoch

Loop2:
              ADD       SI,DX                    (* Eine Zeile Runter *)
              MOVSW
              MOV       [SI+0FFFEH],AX
              LOOP      Loop2

              POP       CX

(* Rechte Untere Ecke *)
              ADD       SI,DX
              MOVSW
              MOV       AL,RU
              MOV       [SI+0FFFEH],AX

(* Linke Seite Schreiben *)
              MOV       AL,Hoch
              LDS       SI,ScrMerk               (* Adresse links oben *)
              INC       SI
              INC       SI                       (* +1 *)

Loop3:
              ADD       SI,DX
              MOVSW
              MOV       [SI+0FFFEH],AX
              LOOP      Loop3

(* Linke Untere Ecke *)
              MOV       AL,LU
              ADD       SI,DX
              MOVSW
              MOV       [SI+0FFFEH],AX

(* Rand Unten *)
             POP        CX                       (* Spaltenzahl! *)
             MOV        AL,Gerade

Loop4:
             MOVSW
             MOV        [SI+0FFFEH],AX
             LOOP       Loop4

             JMP        Fertig                   (* Rahmen gesetzt *)


DoOff:
(*            Pointer Vorbereiten *)
              LES       DI,ScrMerk               (* Ziel ist der Schirm *)
              LDS       SI,Buf                   (* Quelle der Puffer *)
(* Obere Reihe *)
              MOV       CX,XU
              SUB       CX,XO
              INC       CX                       (* Rechts-Inks+1 = Lnge *)
              PUSH      CX                       (* Merken! *)

              REP       MOVSW                    (* Ab in den Schirm! *)

(* Rechte Reihe incl. Ecke unten *)
              MOV       CX,YU
              SUB       CX,YO                    (* Unten-Oben=Hhe+Ecke *)
              PUSH      CX                       (* Merken *)

Loop5:
              ADD       DI,DX                    (* ZeilenSprung *)
              MOVSW
              LOOP      Loop5

(* Linke Reihe Incl. Ecke *)
              LES       DI,ScrMerk
              INC       DI
              INC       DI
              POP       CX

Loop6:
              ADD       DI,DX
              MOVSW
              LOOP      Loop6

(* Untere Reihe ohne Ecken! *)
              POP       CX
              DEC       CX
              DEC       CX

              REP       MOVSW
                                                 (* Rahmen Weg! *)
(*-------------------- *)
Fertig:
              POP       DS                       (* Sonst flippt FST *)
    END; (* ASM *)
  END SetRahmen;

PROCEDURE FrameOff;
  BEGIN
    SetRahmen(FrameXOben,FrameYOben,FrameXUnten,FrameYUnten,
              SavedScreen,FALSE);
    FramePutted:=FALSE;
  END FrameOff;

PROCEDURE PutXORFrame(XPos1,YPos1,XPos2,YPos2:CARDINAL);
  BEGIN
    IF NOT FrameBufAllocated THEN
      IF Available(10000) THEN
        ALLOCATE(SavedScreen,(ScreenCols*2 + ScreenRows*2)*BytesPerChar);
        FrameBufAllocated := TRUE;
      ELSE
        RETURN;
      END;
    END;

    IF FramePutted THEN
      FrameOff;
    END;
    FrameXOben:=XPos1;
    FrameYOben:=YPos1;
    FrameXUnten:=XPos2;
    FrameYUnten:=YPos2;
    SetRahmen(FrameXOben,FrameYOben,FrameXUnten,FrameYUnten,
              SavedScreen,TRUE);
    FramePutted:=TRUE;
  END PutXORFrame;

PROCEDURE KillXORFrame;
  BEGIN
    IF FramePutted THEN
      FrameOff;
      DEALLOCATE(SavedScreen,(ScreenCols*2 + ScreenRows*2)*BytesPerChar);
      FrameBufAllocated := FALSE;
    END;
  END KillXORFrame;



PROCEDURE Init;
BEGIN
    ASM
      MOV AX,40H      (* BIOS-Datensegment *)
      MOV ES,AX

      MOV AX,0B000H       (* Segment VideoRam HGC + MDA *)
      MOV BL,ES:[49H]     (* BIOS-Variable VideoModus *)
      CMP BL,7            (* Ist es MDA,HGC oder EGA/VGA im MonoModus? *)
      JZ  NoColor         (* Jau *)
      ADD AX,800H         (* AX= Segment VideoRam CGA (EGA,VGA Colormoudus) *)
    NoColor:
      MOV ScreenBase,AX   (* Programmvariable laden *)

      MOV AX,ES:[4AH]     (* BIOS-Variable Zeichen/Zeile *)
      MOV ScreenCols,AX   (* Merken *)

      MOV BX,AX           (* Spaltenzahl wird als Divisor gebraucht *)
      MOV AX,ES:[4CH]     (* BIOS-Variable Lnge VideoRam in Bytes *)
      SHL BX,1            (* 2 Byte / Zeichen *)
      DIV BL              (* RamLnge / ZeilenLnge in Bytes = Zeilenzahl! *)
      XOR AH,AH           (* AH= Rest - hier unbrauchbar *)
      MOV ScreenRows,AX   (* Und merken *)
    END;
    IF ScreenBase=0B000H THEN
      NormAttr   :=   NORMAL;    (* Vorgaben fr Mono! *)
      HighAttr   :=   HELL;
      InversAttr :=   MATT_INVERS;
      LastCurLine:=  16;
    ELSE
      NormAttr   :=  (BLAU * 16) + HELLWEISS;
      HighAttr   :=  (WEISS * 16) + SCHWARZ;
      InversAttr :=  (ROT  * 16) + HELLWEISS;
      LastCurLine:=   8;
    END;
  ASM
    MOV AH,01       (* Funktion Definiere Cursorgre *)
    MOV CH,0        (* Startzeile Cursor              *)
    MOV CL,BYTE [LastCurLine]
    INT 10H         (* Video-Interrupt *)
  END;
  BytesPerChar:=2;
  FramePutted:=FALSE;       (* Noch kein Rahmen auf dem Schirm *)
  FrameBufAllocated:=FALSE; (* Und kein Puffer angelegt          *)
END Init;
BEGIN
 Init;
END ScreenLo.
