IMPLEMENTATION MODULE UserInput;
(* $L+ *)
FROM SYSTEM    IMPORT ASSEMBLER;
FROM Storage   IMPORT Available,ALLOCATE,DEALLOCATE;
FROM ScreenLo  IMPORT NormAttr,HighAttr,InversAttr;
FROM Windows   IMPORT WindowTyp,RahmenTyp,OpenWindow,CloseWindow,
                      WinPrintString,WinPrintPartOfString,
                      WinClear,WinSetCursor,NewInfo,DelInfo;

FROM IBMKbd    IMPORT WaitKey,InsSet,ASCII,
                      Tab,ShiftTab,Return,Esc,ArrUp,ArrDown,ArrLeft,ArrRight,
                      Del,Home,End,BackSpace,
                      NPArrUp,NPArrDown,NPArrLeft,NPArrRight,
                      NPDel,NPHome,NPEnd;


IMPORT Strings,NumberConversion;


  PROCEDURE Min(Wert1,Wert2:CARDINAL):CARDINAL;
    BEGIN
     IF Wert1 <= Wert2 THEN
       RETURN Wert1;
     ELSE
       RETURN Wert2;
     END;
   END Min;


  PROCEDURE InputString(XPos,YPos:CARDINAL;     (* Absolute Schirmkoordinaten *)
                        VAR Str:ARRAY OF CHAR;  (* Der Eingabestring          *)
                        MaxLen,                 (* Erlaubte Lnge (<=HIGH!)   *)
                        ShowLen:CARDINAL;       (* Lnge der Anzeige          *)
                        LastKey:CHAR            (* Taste, mit der die Eingabe
                                                   beendet wurde              *)
                        ):BOOLEAN;              (* FALSE, wenn abgebrochen    *)

  (* TastenCodes Editiertasten bei IBM Pc,AT,PS/2 *)

  VAR
     IWin:WindowTyp;
     Done:BOOLEAN;
     ILinePtr:POINTER TO ARRAY[0..256] OF CHAR; (* Das Reicht ja wohl? *)
     FirstX,CurrentX,StrLen:CARDINAL;
     LineAttr:CARDINAL;
     Blanks:ARRAY[0..255] OF CHAR;
     TastCode,Shift:CARDINAL;
     Abgebrochen:BOOLEAN;


  PROCEDURE InsChar;
    VAR DummyStr:ARRAY[0..1] OF CHAR;
    BEGIN
      IF StrLen < MaxLen THEN
        DummyStr[0]:=ASCII(TastCode);
        DummyStr[1]:=0C;
        IF CurrentX < StrLen THEN
          Strings.Insert(DummyStr,ILinePtr^,CurrentX-1);
        ELSE
          Strings.Append(ILinePtr^,DummyStr);
        END;
        INC(StrLen);
      END;
    END InsChar;

  PROCEDURE PutChar;
    BEGIN
      ILinePtr^[CurrentX-1]:=ASCII(TastCode);
      IF CurrentX > StrLen THEN
        ILinePtr^[CurrentX] :=0C;
        INC(StrLen);
      END;
    END PutChar;

  PROCEDURE HandleChar;
    BEGIN
      IF InsSet(Shift) THEN
        InsChar;
      ELSE
        PutChar;
      END;
      IF CurrentX < MaxLen THEN
        INC(CurrentX);
        IF CurrentX >= FirstX+ShowLen THEN
          INC(FirstX);
        END;
      END;
    END HandleChar;

  PROCEDURE DelChar;
    BEGIN
      Strings.Delete(ILinePtr^,CurrentX-1,1);
      DEC(StrLen);
    END DelChar;

  PROCEDURE PrintILine;
    VAR Count:CARDINAL;
    BEGIN
      Count:=Min(StrLen-FirstX+1,ShowLen);
      WinPrintPartOfString(1,1,LineAttr,ILinePtr^,FirstX,Count);
      IF Count < ShowLen THEN
        WinPrintPartOfString(Count+1,1,LineAttr,Blanks,1,ShowLen-Count+1);
      END;
      WinSetCursor(CurrentX-FirstX+1,1);
    END PrintILine;

  PROCEDURE Init():BOOLEAN;
    VAR Lauf:CARDINAL;
    BEGIN
      LineAttr:=InversAttr;
      Done:=FALSE;
      Abgebrochen:=TRUE;
      IF NOT Available(10000) THEN
        RETURN FALSE;
      ELSE
        ALLOCATE(ILinePtr,MaxLen+1);
        StrLen:=Strings.Length(Str);
        Strings.Assign(Str,ILinePtr^);
        FirstX:=1;
        CurrentX:=1;
        FOR Lauf:=0 TO ShowLen-1 DO
          Blanks[Lauf]:=' ';
        END;
        Blanks[ShowLen]:=0C;
        NewInfo('Editieren: Pfeil Links/Rechts,Del,BackSpace,Ins  Abbruch:ESC Ende: Return');
      END;

      IF OpenWindow(IWin,XPos,YPos,XPos+ShowLen-1,YPos,NormAttr,
                 0,Kein,0,'',WinClear)=FALSE THEN
        DEALLOCATE(ILinePtr,MaxLen+1);
        RETURN FALSE;
      END;
      RETURN TRUE;
    END Init;

  PROCEDURE HandleDoInput;
    BEGIN
      Strings.Assign(ILinePtr^,Str);
      Done:=TRUE;
      Abgebrochen:=FALSE;
    END HandleDoInput;

  PROCEDURE CleanUp;
    BEGIN
      DEALLOCATE(ILinePtr,MaxLen+1);
      CloseWindow(IWin);
      DelInfo;
    END CleanUp;

  BEGIN (* InputString *)
    IF Init()=FALSE THEN
      RETURN FALSE;
    END;
    PrintILine;
    WaitKey(TastCode,Shift);
    LineAttr:=NormAttr;
    IF (TastCode<>Return) AND (TastCode<>Esc) AND (TastCode<>Tab) THEN
      StrLen:=0;
      ILinePtr^[0]:=0C;
    END;
    REPEAT
      CASE TastCode OF
        ArrUp,ArrDown,
        NPArrUp,NPArrDown,
        Tab,
        ShiftTab  : IF SpecTastReaktion = Abbruch THEN
                       Done:=TRUE;
                     ELSIF SpecTastReaktion = Eingabe THEN
                       HandleDoInput;
                     END;
      | ArrLeft,
        NPArrLeft  : IF CurrentX > 1 THEN DEC(CurrentX) END;
                     IF CurrentX<FirstX THEN DEC(FirstX); END;
      | ArrRight,
        NPArrRight : IF CurrentX < MaxLen+1 THEN INC(CurrentX) END;
                     IF CurrentX >= FirstX+ShowLen THEN INC(FirstX); END;
      | Del,
        NPDel      : IF CurrentX <= StrLen THEN DelChar; END;
      | Home,
        NPHome     : CurrentX:=1; FirstX:=1;
      | End,
        NPEnd      : CurrentX:=StrLen+1;
                   IF CurrentX >= FirstX+ShowLen THEN
                     FirstX:=CurrentX-ShowLen;
                   END;
      | BackSpace : IF CurrentX > 1 THEN
                      DEC(CurrentX);
                      IF CurrentX < FirstX THEN
                        DEC(FirstX);
                      END;
                      DelChar;
                    END;
      | Esc       : Done:=TRUE;
      | Return    : HandleDoInput;
        ELSE        HandleChar;
      END; (* case *)
      PrintILine;
      IF Done=FALSE THEN WaitKey(TastCode,Shift); END;
    UNTIL Done=TRUE;
    LastKey:=ASCII(TastCode);
    CleanUp;
    RETURN NOT Abgebrochen;
  END InputString;

PROCEDURE InputErr;
  VAR Code,Shift:CARDINAL;
  BEGIN
    NewInfo('Ungltiger Wert, bitte wiederholen oder Abbrechen! Taste..');
    WaitKey(Code,Shift);
    DelInfo;
  END InputErr;

PROCEDURE InputCard(XPos,YPos:CARDINAL;
                    VAR Number:CARDINAL; LastKey:CHAR):BOOLEAN;
  VAR Trans:ARRAY[0..5] OF CHAR;
      Ok,Break:BOOLEAN;
  BEGIN
    NumberConversion.CardToString(Number,Trans,5);
    WHILE Trans[0]=' ' DO
      Strings.Delete(Trans,0,1);
    END;
    REPEAT
      Break:=NOT InputString(XPos,YPos,Trans,5,5,LastKey);
      IF NOT Break THEN
        NumberConversion.StringToCard(Trans,Number,Ok);
        IF NOT Ok THEN
          InputErr;
        END;
      END;
    UNTIL (Break OR Ok);
    RETURN (NOT Break) OR Ok;
  END InputCard;


PROCEDURE InputInt(XPos,YPos:CARDINAL;
                    VAR Number:INTEGER; LastKey:CHAR):BOOLEAN;
  VAR Trans:ARRAY[0..6] OF CHAR;
      Ok,Break:BOOLEAN;
  BEGIN
    NumberConversion.IntToString(Number,Trans,6);
    WHILE Trans[0]=' ' DO
      Strings.Delete(Trans,0,1);
    END;
    REPEAT
      Break:=NOT InputString(XPos,YPos,Trans,6,6,LastKey);
      IF NOT Break THEN
        NumberConversion.StringToInt(Trans,Number,Ok);
        IF NOT Ok THEN
          InputErr;
        END;
      END;
    UNTIL (Break OR Ok);
    RETURN (NOT Break) OR Ok;
  END InputInt;


PROCEDURE InputBool(XPos,YPos:CARDINAL; VAR Wert:BOOLEAN; LastKey:CHAR):BOOLEAN;
  VAR BString:ARRAY[0..3] OF CHAR;
      Code,Shift:CARDINAL; Done,Break:BOOLEAN;
      IWin:WindowTyp;
  BEGIN

    IF OpenWindow(IWin,XPos,YPos,XPos+3,YPos,NormAttr,0,Kein,0,'',WinClear) THEN
      Done:=FALSE;
      Break:=FALSE;
      IF Wert=TRUE THEN
        BString:=' Ja ';
      ELSE
        BString:='Nein';
     END;
     WinPrintString(1,1,NormAttr,BString);
     REPEAT
       WaitKey(Code,Shift);
       CASE ASCII(Code) OF
         'j','J'  : Done := TRUE;
                    Wert := TRUE;
        |'n','N'  : Done := TRUE;
                    Wert := FALSE;
         ELSE       Break:= TRUE;
       END; (* case *)
     UNTIL (Done OR Break);
     CloseWindow(IWin);
   ELSE
     Break:=TRUE;
   END;
   RETURN NOT Break;
  END InputBool;

END UserInput.


