IMPLEMENTATION MODULE XORGraph;
(*==========================================================================*)
(*                           XORGraph                                       *)
(*==========================================================================*)
(*   Setzt Graphic in den XOR-Modus, d.h. bereits gezeichnete Objekte       *)
(*   knnen 'durchscheinen'.                                                *)
(*--------------------------------------------------------------------------*)
(*   (C) Dieter Kreimann, Hamburg                                           *)
(*--------------------------------------------------------------------------*)
(*   Status : Frei                                                          *)
(*   Date   : 08.08.89                                                      *)
(*--------------------------------------------------------------------------*)
(*   For TOPSPEED MODULA2, Module Graph                                     *)
(*--------------------------------------------------------------------------*)
(*$V-,I-,R-,S-*)
(*--------------------------------------------------------------------------*)
FROM Graph IMPORT NumColor, PlotProc, HLineProc, Plot, Point, HLine;

VAR xorMode   : BOOLEAN;
    savePlot  : PlotProc;
    saveHLine : HLineProc;
(*--- internal -------------------------------------------------------------*)
PROCEDURE xorModePlot ( x, y, c : CARDINAL );
(*   Punkte setzen im XOR-Modus                                             *)
VAR col : CARDINAL;
BEGIN
  c := c MOD NumColor;
  col := Point ( x, y );
  IF c < col THEN
    savePlot ( x, y, col - c );
  ELSE
    savePlot ( x, y, c - col );
  END;
END xorModePlot;
(*--------------------------------------------------------------------------*)
PROCEDURE xorModeHLine ( x0, y, x1, c : CARDINAL );
(*   Horizontal Linie im XOR-Modus                                          *)
VAR col, i : CARDINAL;
BEGIN
  c := c MOD NumColor;
  FOR i := x0 TO x1 DO
    col := Point ( i, y );
    IF c < col THEN
      savePlot ( i, y, col - c );
    ELSE
      savePlot ( i, y, c - col );
    END;
  END;
END xorModeHLine;
(*--- exported -------------------------------------------------------------*)
PROCEDURE SetMode ( mode : eMode );
(*  Setzen des Modus auf Normal/XOR                                         *)
BEGIN
  IF (mode = XOR) AND NOT xorMode THEN
    savePlot := Plot;
    saveHLine := HLine;
    Plot := xorModePlot;
    HLine := xorModeHLine;
    xorMode := TRUE;
  ELSIF (mode = Normal) AND xorMode THEN
    Plot := savePlot;
    HLine := saveHLine;
    xorMode := FALSE;
  END;
END SetMode;
(*--- Body -----------------------------------------------------------------*)
BEGIN
  xorMode := FALSE;
(*   Vorbesetzung: Normal-Modus                                             *)
END XORGraph.
