MODULE HashTest;

FROM SYSTEM IMPORT ADDRESS, ADR, TSIZE;
FROM InOut IMPORT WriteString, WriteCard, WriteLn, WriteCard,
                  OpenInput, CloseInput, Read, Done,
                  OpenOutput, CloseOutput;
FROM HASH IMPORT  Table, Init, Exit, Member, Insert, Manipu, WriteAll,
                  TableFree, Count;
FROM BigArrays IMPORT BigArray, InitArray, GetItem, PutItem, ExitArray,
                   SortArray;

CONST MaxLength = 20;

TYPE Item = RECORD
              Name : ARRAY[0..MaxLength] OF CHAR;
              Count : CARDINAL
            END;

VAR T : Table;
    l,Index,ItemCount : CARDINAL;
    State : (Skip,Sample);
    C : CHAR;
    It : Item;
    ItemArray : BigArray;
    ItemPtr : POINTER TO Item;

PROCEDURE ItemEqual(t1, t2 : ADDRESS) : BOOLEAN;
  VAR I1, I2 : POINTER TO Item; i : CARDINAL;
  BEGIN
    I1:=t1; I2:=t2; i:=0;
    WHILE (i<=MaxLength) AND (I1^.Name[i]=I2^.Name[i]) AND (I1^.Name[i]<>0C)
    DO INC(i)
    END;
    RETURN (i>MaxLength) OR (I1^.Name[i]=I2^.Name[i])
  END ItemEqual;

PROCEDURE H(t : ADDRESS):CARDINAL;
  VAR It : POINTER TO Item;
      i, s : CARDINAL;
  BEGIN
    It:=t; i:=0; s:=0;
    WHILE (i<=MaxLength) AND (It^.Name[i]<>0C)
      DO INC(s,ORD(It^.Name[i])); INC(i)
    END;
    RETURN s
   END H;

PROCEDURE WriteItem(t : ADDRESS);
  VAR It : POINTER TO Item;
  BEGIN
    It:=t;
    WriteCard(It^.Count,5);
    WriteString(" x ");
    WriteString(It^.Name);
    WriteLn
  END WriteItem;

PROCEDURE IncItem(t : ADDRESS);
  VAR It : POINTER TO Item;
  BEGIN
    It:=t;
    INC(It^.Count)
  END IncItem;

PROCEDURE StringLess(VAR X, Y : ARRAY OF CHAR) : BOOLEAN;
  VAR i : CARDINAL;
  BEGIN
    i:=0;
    LOOP
      IF (i>HIGH(X)) OR (i>HIGH(Y)) THEN RETURN HIGH(X)<HIGH(Y)
      ELSIF CAP(X[i])<>CAP(Y[i])
      THEN RETURN CAP(X[i])<CAP(Y[i])
      ELSIF X[i]=0C THEN RETURN FALSE
      ELSE INC(i)
      END
    END
  END StringLess;

PROCEDURE ItemLess(t1, t2 : ADDRESS) : BOOLEAN;
  VAR I1, I2 : POINTER TO Item;
  BEGIN
    I1:=t1; I2:=t2;
    RETURN StringLess(I1^.Name,I2^.Name)
  END ItemLess;

PROCEDURE MoveItem(It : ADDRESS);
  BEGIN
    IF PutItem(ItemArray,Index,It)
    THEN INC(Index)
    ELSE WriteString("Zu wenig Speicher!"); WriteLn
    END
  END MoveItem;

BEGIN
  OpenInput("");
  IF Done THEN
    IF NOT Init(T,100,H,ItemEqual) THEN
      WriteString("Speicher reicht nicht aus");
      WriteLn;
      HALT
    ELSE
      WriteString("Initialisierung ok");
      WriteLn
    END;
    State:=Skip;
    Read(C);
    WHILE Done DO
      CASE State OF
        Skip :   CASE CAP(C) OF
                  "A".."Z",
                  "","","",
                  "","","",
                  "" : l:=0; It.Name[l]:=C; State:=Sample
                 END;
      | Sample : CASE CAP(C) OF
                   "A".."Z",
                   "0".."9",
                  "","","",
                  "","","",
                  "" : IF l<MaxLength
                        THEN INC(l); It.Name[l]:=C
                        END
                  ELSE
                    IF l<MaxLength THEN It.Name[l+1]:=0C END;
                    IF Member(T,ADR(It))
                    THEN Manipu(T,ADR(It),IncItem)
                    ELSE It.Count:=1;
                      IF NOT Insert(T,ADR(It),TSIZE(Item))
                      THEN
                        WriteString("Speicherplatz reicht nicht aus");
                        WriteLn;
                        HALT
                      END
                    END; (* IF *)
                    State:=Skip
                  END (* CASE *)
      END; (* CASE *)
      Read(C)
    END; (* WHILE *)
    CloseInput;
    ItemCount:=Count(T);
    IF NOT InitArray(ItemArray,ItemCount,TSIZE(Item))
    THEN
      WriteString("Zu wenig Speicherplatz");
      WriteLn
    END;
    Index:=0; WriteAll(T,MoveItem);
    SortArray(ItemArray,ItemLess,ItemCount-1);
    OpenOutput("");
    FOR Index:=0 TO ItemCount-1 DO
      IF GetItem(ItemArray,Index,ADR(It))
      THEN WriteItem(ADR(It))
      END
    END;
    CloseOutput;
    Exit(T);
    ExitArray(ItemArray)
  END (* IF Done *)
END HashTest.
