IMPLEMENTATION MODULE LinList;

FROM SYSTEM IMPORT TSIZE;
FROM Storage IMPORT Available, ALLOCATE, DEALLOCATE;

TYPE List = POINTER TO Node;

     Node = RECORD
              MSize : CARDINAL;
              MPtr  : ADDRESS;
              next  : List
            END;

     LListType = RECORD
                     equal : EqualFunc;
                     LL : List
                   END;

     LList = POINTER TO LListType;

PROCEDURE Copy(A, B : ADDRESS; Size : CARDINAL);
  (* Damit werden Size Bytes von A^ nach B^ kopiert. In den meisten
     Modula-2-Implementierungen gibt es hierfr eine schnelle
     Bibliotheksroutine, die selbstverstndlich verwendet werden
     sollte. *)

  PROCEDURE C(VAR X,Y : ARRAY OF BYTE);
    VAR i : CARDINAL;
    BEGIN
      FOR i:=0 TO Size-1 DO
        Y[i]:=X[i]
      END
    END C;

  BEGIN
    C(A^,B^)
  END Copy;

PROCEDURE InitList(VAR L : LList; Eq : EqualFunc) : BOOLEAN;
  BEGIN
    IF NOT Available(TSIZE(LListType))
    THEN RETURN FALSE
    ELSE
      ALLOCATE(L,TSIZE(LListType));
      WITH L^ DO
         LL:=NIL;
         equal:=Eq
      END;
      RETURN TRUE
    END
  END InitList;

PROCEDURE Member(L : LList; Item : ADDRESS) : BOOLEAN;
  VAR p : List;
  BEGIN
    WITH L^ DO
      p:=LL;
      WHILE (p<>NIL) AND NOT equal(p^.MPtr,Item) DO p:=p^.next END;
    END;
    RETURN p<>NIL
  END Member;

PROCEDURE Insert(VAR L : LList; Item : ADDRESS; Size : CARDINAL) : BOOLEAN;
  VAR p : List;
  BEGIN
    IF NOT Available(TSIZE(Node)+Size)
    THEN RETURN FALSE
    ELSE
      ALLOCATE(p,TSIZE(Node));
      WITH p^ DO
        MSize:=Size;
        ALLOCATE(MPtr,Size);
        Copy(Item,MPtr,Size);
        next:=L^.LL
      END;
      L^.LL:=p;
      RETURN TRUE
    END
  END Insert;

PROCEDURE Delete(VAR L : LList; Item : ADDRESS) : BOOLEAN;
  VAR p, q : List;
  BEGIN
    WITH L^ DO 
      IF LL=NIL THEN RETURN FALSE
      ELSIF equal(LL^.MPtr,Item) THEN RETURN TRUE
      ELSE
        p:=LL;
        WHILE (p^.next<>NIL) AND NOT equal(p^.next^.MPtr,Item) DO
          p:=p^.next
        END;
        IF p^.next=NIL
        THEN RETURN FALSE
        ELSE
          q:=p^.next;
          p^.next:=p^.next^.next;
          DEALLOCATE(q,TSIZE(Node));
          RETURN TRUE
        END
      END
    END
  END Delete;

PROCEDURE ExitList(VAR L : LList);
  VAR p,q : List;
  BEGIN
    WITH L^ DO
      p:=LL;
      WHILE p<>NIL DO
        q:=p; p:=p^.next;
        WITH q^ DO DEALLOCATE(MPtr,MSize) END;
        DEALLOCATE(q,TSIZE(Node))
      END;
    END;
    DEALLOCATE(L,TSIZE(LListType));
    L:=NIL
  END ExitList;

END LinList.
