IMPLEMENTATION MODULE Work;

FROM SYSTEM IMPORT ASSEMBLER, ADR, ADDRESS, BYTE;
FROM System IMPORT Move;

CONST
        INDEX=03B4H;
        DMCPORT=03B8H;
        STATUS=03BAH;
        CONFIG=03BFH;
        length = 8;                    (* laenge der zeichenmatrix 8 * length *)

VAR
    x,y,deltax,deltay,xflag,yflag,inc1,inc2,g,flag,col,end,row,
    xloesch,yloesch,xalt,yalt:CARDINAL;
    first:BOOLEAN;                              (* cursor erstesmal geserzt ? *)
    initt:BOOLEAN;                              (* wurde initialisiert ? *)
    PlotBuffer:ARRAY [0..347] OF CARDINAL;      (* offsetadressen fr plot *)
    MatrixBuffer:ADDRESS;                       (* zeichensatzaddresse *)

PROCEDURE DetectHercules():BOOLEAN;
VAR hercules:BOOLEAN;
VAR i,bit,test:CARDINAL;
BEGIN
hercules:=TRUE;                                 (* ersteinmal *)
    ASM
                MOV AH,15                       (* BIOS funktionsauswahl *)
                INT 10H                         (* BIOS einsprung fuer video
                                                   status *)
                CMP AL,7                        (* ist monomode aktiv ? *)
                JE  ACTIV
                MOV AX,FALSE
                MOV hercules,AX
        ACTIV:
    END;
    IF NOT(hercules) THEN RETURN FALSE;END;     (* nicht activ *)
    hercules:=FALSE;                            (* ersteinmal *)
                                                (* jetzt bit 7 testen *)
    ASM                                         (* erstemal einlesen *)
                XOR AX,AX                       (* AX :=0 *)
                MOV DX,STATUS                   (* DX:=STATUSPORT *)
                IN  AL,DX                       (* STATUSPORT einlesen *)
                MOV bit,AX                      (* und in bit speichern *)
                                                (* AL steckt in AX (lowbyte) *)
    END;

                                       (* jetzt nachsehen ob es gleichbleibt *)
    FOR i:=0 TO 200 DO
        ASM
                XOR AX,AX
                MOV DX,STATUS
                IN  AL,DX
                MOV test,AX
        END;
        IF test#bit THEN hercules:=TRUE;END;
    END;
    RETURN hercules;
END DetectHercules;

PROCEDURE InittFastPlot;                    (* initialisiert den plotbuffer *)
VAR pos,i,n:CARDINAL;
BEGIN
IF initt=FALSE THEN                         (* wurde initialisiert dann ende *)
    FOR i:=0 TO 86 DO                       (* 86 durchlauefe -> 688 Bytes *)
        pos:=i*4;                           (* position im buffer *)
        n:=i*90;                            (* zu addierender wert *)
        PlotBuffer[pos]:=n;                 (* 1. in buffer *)
        PlotBuffer[pos+1]:=2000H+n;         (* 2. in buffer *)
        PlotBuffer[pos+2]:=4000H+n;         (* 3. in buffer *)
        PlotBuffer[pos+3]:=6000H+n;         (* 4. in buffer *)
    END;
    initt:=TRUE;                            (* es wurde initialisiert *)
    first:=TRUE;                            (* Cursor noch nicht aufgerufen *)
    xalt:=0;yalt:=0;
END;
END InittFastPlot;


PROCEDURE InitWrite(adr:ADDRESS);       (* initialisiert zeichensatz *)
VAR i:CARDINAL;
BEGIN
MatrixBuffer:=adr;                      (* addresse fr zeichensatz festlegen *)
END InitWrite;

PROCEDURE WaitForVerticalRetrace;
BEGIN
 ASM
                MOV DX,STATUS            (* STATUSPORT *)
         LOOP1:
                IN AL,DX
                SHL AL,1
                JNC LOOP1
         LOOP2:
                IN AL,DX
                SHL AL,1
                JC  LOOP2
  END;
END WaitForVerticalRetrace;

PROCEDURE Out(data1,data2:CARDINAL);    (* nur fr 6845 Register *)
BEGIN
    ASM
                MOV DX,INDEX		(* INDEX in DX *)
                MOV AX,data1		(* Nr. in AX *)
                OUT DX,AL		(* und in Register schreiben *)
                INC DX			(* DX erhoehen *)
                MOV AX,data2		(* Wert in AX *)
                OUT DX,AL		(* und einschreiben *)
					(* Anm.: AL ist Low-Byte von AX *)
    END;
END Out;

PROCEDURE Graphic;
BEGIN
InittFastPlot;                      (* wird nur das erstemal ausgefhrt *)
 ASM

        (* KONFIGURATION PROGRAMMIEREN *)

                MOV DX,CONFIG        (* KONFIGURATION *)
                MOV AH,1            (* GRAPHIC UND NICHT PAGE 1 MOEGLICH *)
                MOV AL,AH
                OUT DX,AL           (* SCHREIBEN DER CONFIGURATION *)

       (* DMC PORT PROGRAMIEREN *)

                MOV DX,DMCPORT        (* DMC Port *)
                MOV AH,2              (* GRAPHIC AN, DISPLAY AUS *)
                MOV AL,AH
                OUT DX,AL

       (* 6845 PROGRAMMIERUNG *)

                CLI

    END;
(*
       ACHTUNG:
       DIE FOLGENDEN WERTE MSSEN UNBEDINGT RICHTIG SEIN DA SONST DER
       MONITOR ZERSTRT WERDEN KANN !!!
*)
                Out(0,35H);
                Out(1,2DH);
                Out(2,2EH);
                Out(3,07H);
                Out(4,5BH);
                Out(5,02H);
                Out(6,57H);
                Out(7,57H);
                Out(8,02H);
                Out(9,03H);
                Out(10,00H);
                Out(11,00H);

       (* DMC PORT PROGRAMMIEREN *)
    ASM
                CALL WaitForVerticalRetrace
                MOV DX,DMCPORT                   (* DMC Port *)
                MOV AH,42                        (* GRAPHIC AN, DISPLAY AN *)
                MOV AL,AH
                OUT DX,AL

 END;
END Graphic;


PROCEDURE Text;                     (* schaltet in monochromen textmode *)
BEGIN
 ASM
                MOV AX,7            (* funktionsauswahl fuer ISR *)
                INT 10H             (* BIOS Interruptroutine *)
 END;
END Text;

PROCEDURE Clear;                            (* Loescht die Graphicseite *)
BEGIN
 ASM
                PUSH BP                     (* BP retten *)
                MOV BP,0B000H               (* segment festlegen *)
                MOV ES,BP                   (* und nach ES geben *)
                XOR DI,DI                   (* DI:=0 *)
                XOR AX,AX                   (* AX:=0 *)
                MOV CX,04000H               (* 1/2 kilobyte,1 wort hat 2 byte *)
                CLD
                REP STOSW                   (* und 1/2 kilobyte loeschen *)
                POP BP
  END;
 END Clear;


PROCEDURE XPlot(x,y:CARDINAL);              (* setzt pixel oder loescht es *)
BEGIN
 xalt:=x;
 yalt:=y;
 ASM
                PUSH BP                     (* segment festlegen *)
                MOV BP,0B000H
                MOV ES,BP                   (* und nach ES *)
                POP BP

                MOV DI,347                  (* um unten 0,0 zu haben *)
                MOV AX,y                    (* y-position *)
                SUB DI,AX                   (* von 347 subtrahieren *)
                SHL DI,1
                MOV DI,PlotBuffer[DI]       (* addresse holen *)

                MOV AX,x                    (* x-position holen *)
                SHR AX,1                    (* durch 2 teilen (DIV) *)
                SHR AX,1                    (* nochmal durch zwei *)
                SHR AX,1                    (* und nocheinmal durch zwei *)
                                            (* insgesamt durch 8 geteilt, da
                                                ein byte 8 bit hat *)
                ADD DI,AX                   (* und zur addresse adieren *)

                MOV AX,x                    (* x-position holen *)
                AND AX,7                    (* nur lowbyte berlassen *)
                MOV CL,AL                   (* untere 8 bits von AX *)
                MOV AX,128                  (* das 7. Bit besetzen *)
                ROR AX,CL                   (* und um CL nach rechts schieben *)
                XOR  ES:[DI],AL             (* lschen oder pixel setzen *)
 END;
END XPlot;



PROCEDURE Drawx(xa,xe,y:CARDINAL);          (* zieht linie bei konstantem y *)
BEGIN
IF (xa>719) OR (xe>719) OR (y>347) THEN RETURN;END;
IF xa=xe THEN Plot(xa,y);RETURN;END;
 ASM
                MOV DI,347
                MOV AX,y
                SUB DI,AX
                SHL DI,1
                MOV DI,PlotBuffer[DI]
                MOV SI,DI               (* SICHERN *)


                MOV AX,0
                MOV xflag,AX
                MOV AX,xe
                SUB AX,xa
                JGE P1
                NEG AX
                INC xflag
        P1:     MOV deltax,AX
                MOV CX,AX
        LOOPX:  MOV AX,xa
                SHR AX,1
                SHR AX,1
                SHR AX,1
                ADD DI,AX
                MOV AX,xa
                AND AX,7
                MOV BX,CX
                MOV CL,AL
                MOV AX,128
                ROR AX,CL
                OR  ES:[DI],AL
                MOV CX,BX
                DEC CX
                JCXZ DRAWXEND
                MOV DI,SI
                CMP xflag,0
                JE INCX
                DEC xa
                JMP LOOPX
       INCX:    INC xa
                JMP LOOPX
    DRAWXEND:
 END;
END Drawx;

PROCEDURE Drawy(ya,ye,x:CARDINAL);      (* zieht linie bei konstantem x *)
BEGIN
IF (ya>347) OR (ye>347) OR (x>719) THEN RETURN;END;
IF ya=ye THEN Plot(x,ya);RETURN;END;
 ASM
                MOV DI,347          (* y-koordinaten umdrehen *)
                MOV AX,ya
                SUB DI,AX
                MOV AX,DI
                MOV ya,AX
                MOV DI,347
                MOV AX,ye
                SUB DI,AX
                MOV AX,DI
                MOV ye,AX

                MOV AX,x
                SHR AX,1
                SHR AX,1
                SHR AX,1
                MOV SI,AX           (* DI OFFSET *)
                MOV AX,x
                AND AX,7
                MOV CL,AL
                MOV AX,128
                ROR AX,CL
                MOV BX,AX            (* BYTE SICHERN - ZERSTOERT x *)

                MOV AX,0
                MOV yflag,AX
                MOV AX,ye
                SUB AX,ya
                JGE P1
                INC yflag
                NEG AX
           P1:  MOV deltay,AX
                MOV CX,AX

                PUSH BP
                MOV BP,0B000H
                MOV ES,BP
                POP BP

      LOOPY:    MOV AX,ya
                MOV DI,AX
                SHL DI,1
                MOV DI,PlotBuffer[DI]
                ADD DI,SI
                MOV AX,BX                    (* BYTE ZURUECKHOLEN *)
                OR  ES:[DI],AL

                DEC CX
                JCXZ DRAWYEND
                CMP yflag,0
                JE  INCY
                DEC ya
                JMP LOOPY
         INCY:  INC ya
                JMP LOOPY
     DRAWYEND:
 END;
END Drawy;


PROCEDURE Plot(x,y:CARDINAL);               (* setzt einen punkt *)
BEGIN                                       (* kommentare bei XPlot *)
 xalt:=x;
 yalt:=y;
 ASM
                MOV AX,x
                MOV BX,y
                CALL plot
 END;
END Plot;

PROCEDURE plot;                         (* plotroutine fuer assembler *)
BEGIN
 ASM
                PUSH CX

                MOV x,AX
                MOV y,BX

                MOV DI,347
                MOV AX,y                    (* Y-POSITION *)
                SUB DI,AX                   (* Y IN DI *)
                SHL DI,1
                MOV DI,PlotBuffer[DI]

                MOV AX,x                    (* X-POSITIONR *)
                SHR AX,1
                SHR AX,1
                SHR AX,1

                ADD DI,AX

                MOV AX,x
                AND AX,7
                MOV CL,AL
                MOV AX,128
                ROR AX,CL
                OR  ES:[DI],AL
                POP CX

 END;
END plot;

PROCEDURE Line(xanf,xend,yanf,yend:CARDINAL);       (* zieht linie *)
BEGIN
 ASM
                PUSH AX
                PUSH BX
                PUSH CX
                PUSH DX
                PUSH ES


                MOV AX,xanf
                SUB AX,xend                 (* anfang=ende ? *)
                JNZ START
                MOV AX,yanf
                SUB AX,yend
                JNZ START
                MOV AX,xanf
                MOV BX,yanf
                CALL plot
                JMP LINEEND

    START:      MOV BX,0B000H               (* ES auf grafikaddresse *)
                MOV ES,BX                   (* setzen *)


                                            (* delta x berechnen *)
                MOV AX,xanf                 (* anfangspunt x *)
                SUB AX,xend                 (* delta x berechnen *)
                JGE P1                      (* springe wenn positiv *)
                NEG AX                      (* absolutwert deltax *)
    P1:         MOV deltax,AX               (* delta x speichern *)
                                            (* delta y berechnen *)
                MOV AX,yanf                 (* anfangspunkt y *)
                SUB AX,yend                 (* delta y berechnen *)
                JGE P2                      (* springe wenn positiv *)
                NEG AX                      (* absolutwert deltay *)
    P2:         MOV deltay,AX               (* deltay speichern *)
                                            (* mit x oder y zaehlen ? *)
                SUB AX,deltax               (* welche strecke ist laenger *)
                JGE YLAUF                   (* wenn positiv dann mit y *)


    XLAUF:                                  (* zaehle mit x *)
                MOV AX,deltay               (* deltay in AX *)
                SHL AX,1                    (* x2 *)
                MOV inc1,AX                 (* in inc1 speichern *)
                MOV AX,deltay               (* deltay in AX *)
                MOV DX,deltax
                SHL AX,1
                SHL DX,1
                SUB AX,DX                  (* -delta x *)
                MOV inc2,AX                 (* in inc2 speichern *)
                MOV AX,deltay               (* deltay in AX *)
                SHL AX,1                    (* x2 *)
                SUB AX,deltax               (* -deltax *)
                ADD AX,32768                (* offset zum pruefen *)
                MOV g,AX                    (* in g speichern *)

                MOV DX,1                    (* DX = 1 *)
                MOV AX,yend
                SUB AX,yanf                 (* differenz bilden *)
                JGE  FLAGENDX               (* wenn >= 0 spring *)
                NEG DX                      (* DX=-1 *)
    FLAGENDX:   MOV flag,DX                 (* flage setzen *)

                MOV AX,xanf
                SUB AX,xend                 (* - xend *)
                JGE P3X
                MOV AX,xanf
                MOV col,AX
                MOV AX,xend
                MOV end,AX
                MOV AX,yanf
                MOV row,AX
                JMP P4X
    P3X:        MOV AX,xend
                MOV col,AX                  (* xanf in col *)
                MOV AX,xanf
                MOV end,AX
                MOV AX,yend
                MOV row,AX
                NEG flag
    P4X:                                    (* ausfuehern der linie *)
                MOV CX,end                  (* anzahl der durchlaeufe *)
                SUB CX,col                  (* berechnen und in DX *)
    P5X:                                    (* schleife *)
                MOV AX,col
                MOV BX,row
                CALL plot               (* plotroutine fuer pixel *)
                INC col                     (* naechstes spalte *)
                MOV AX,g                    (* g laden *)
                CMP AX,32768                (* groesser 0 ? (32768) *)
                JB  P6X                     (* nein dann P6 *)
                ADD AX,inc2                 (* g=g+inc2 *)
                MOV g,AX                    (* speichern *)
                MOV AX,row                  (* reihe in AX *)
                ADD AX,flag                 (* -1 oder +1 *)
                MOV row,AX                  (* und speichern *)
                JMP LOOPENDX                (* naechste schleife *)
    P6X:
                ADD AX,inc1                 (* g=g+inc1 *)
                MOV g,AX                    (* und speichern *)

    LOOPENDX:   LOOP P5X                    (* schleife wiederholen *)
                JMP LINEEND

    YLAUF:                                  (* zaehle mit y *)
                MOV AX,deltax               (* deltax in AX *)
                SHL AX,1                    (* x2 *)
                MOV inc1,AX                 (* in inc1 speichern *)
                MOV AX,deltax               (* deltax in AX *)
                MOV DX,deltay
                SHL AX,1
                SHL DX,1
                SUB AX,DX                  (* -delta y *)
                MOV inc2,AX                 (* in inc2 speichern *)
                MOV AX,deltax               (* deltax in AX *)
                SHL AX,1                    (* x2 *)
                SUB AX,deltay               (* -delta y *)
                ADD AX,32768                (* offset zum pruefen *)
                MOV g,AX                    (* in g speichern *)

                MOV DX,1                    (* DX = 1 *)
                MOV AX,xend
                SUB AX,xanf                 (* differenz bilden *)
                JGE FLAGENDY                (* wenn >= 0 spring *)
                NEG DX                      (* DX=-1 *)
    FLAGENDY:   MOV flag,DX                 (* flage setzen *)

                MOV AX,yanf
                SUB AX,yend                 (* - yend *)
                JGE P3Y
                MOV AX,yanf
                MOV col,AX
                MOV AX,yend
                MOV end,AX
                MOV AX,xanf
                MOV row,AX
                JMP P4Y
    P3Y:        MOV AX,yend
                MOV col,AX                  (* yanf in col *)
                MOV AX,yanf
                MOV end,AX
                MOV AX,xend
                MOV row,AX
                NEG flag
    P4Y:                                    (* ausfuehern der linie *)
                MOV CX,end                  (* anzahl der durchlaeufe *)
                SUB CX,col                  (* berechnen und in DX *)
    P5Y:                                    (* schleife *)
                MOV AX,row
                MOV BX,col
                CALL plot               (* plotroutine fuer pixel *)
                INC col                     (* naechstes spalte *)
                MOV AX,g                    (* g laden *)
                CMP AX,32768                (* groesser 0 ? (32768) *)
                JB  P6Y                     (* nein dann P6 *)
                ADD AX,inc2                 (* g=g+inc2 *)
                MOV g,AX                    (* speichern *)
                MOV AX,row                  (* reihe in AX *)
                ADD AX,flag                 (* -1 oder +1 *)
                MOV row,AX                  (* und speichern *)
                JMP LOOPENDY                (* naechste schleife *)
    P6Y:
                ADD AX,inc1                 (* g=g+inc1 *)
                MOV g,AX                    (* und speichern *)

    LOOPENDY:   LOOP P5Y                    (* schleife wiederholen *)

    LINEEND:
                POP ES
                POP DX
                POP CX
                POP BX
                POP AX

 END;
END Line;

PROCEDURE OneChar(x,y:CARDINAL;charwords:ARRAY OF CHAR);
VAR dummy:CHAR;
VAR i:CARDINAL;
BEGIN
    y:=y+length;                         (* untere linke ecke ist ursprung *)
    FOR i:=0 TO length-1 DO
        dummy:=charwords[i];
        y:=y-1;
        ASM

                PUSH ES
                PUSH BP
                MOV BP,0B000H
                MOV ES,BP
                POP BP


                MOV DI,347                  (* UM UNTEN 0,0 ZU HABEN *)
                MOV AX,y                    (* Y-POSITION *)
                SUB DI,AX
                SHL DI,1
                MOV DI,PlotBuffer[DI]

                MOV AX,x                    (* X-POSITIONR *)
                SHR AX,1
                SHR AX,1
                SHR AX,1

                ADD DI,AX                   (* entgueltig DI *)
                                            (* jetzt offset *)
                MOV AX,x
                AND AX,7
                MOV CL,AL
                MOV AL,dummy
                ROR AX,CL
                XOR ES:[DI],AX
                POP ES
        END;
    END;
END OneChar;

PROCEDURE GraphWrite(x,y,len:CARDINAL;
                     string:ARRAY OF CHAR;
                     style:CARDINAL);

VAR word:ARRAY [0..length-1] OF CHAR;
VAR yb,dummy,i,count,pos:CARDINAL;
BEGIN

FOR i:=1 TO len DO
    IF string[i-1]=" " THEN
        IF style=0 THEN
            x:=x+5;
        ELSIF style=1 THEN
            y:=y-5;
        ELSIF style=2 THEN
            x:=x+5;
            y:=y+5;
        ELSIF style=3 THEN
            x:=x+5;
            y:=y-5;
        END;
    ELSE
        pos:=(ORD(string[i-1]))*length;
        Move(MatrixBuffer+pos,ADR(word[0]),8);
        OneChar(x,y,word);
        IF style=0 THEN
            x:=x+12;
        ELSIF style=1 THEN
            y:=y-length-2;
        ELSIF style=2 THEN
            x:=x+12;
            y:=y+length+2;
        ELSIF style=3 THEN
            x:=x+12;
            y:=y-length-2;
        END;
    END;
END;
END GraphWrite;


PROCEDURE xline(y:CARDINAL);                (* waagerechte linie ber display *)
BEGIN
    ASM
                MOV DI,347
                MOV AX,y
                SUB DI,AX
                SHL DI,1
                MOV DI,PlotBuffer[DI]
                MOV AX,0FFFFH
                MOV CX,45
        P1:     XOR ES:[DI],AX
                INC DI
                INC DI
                LOOP P1
    END;
END xline;

PROCEDURE yline(x:CARDINAL);
BEGIN
    ASM
                MOV AX,x
                SHR AX,1
                SHR AX,1
                SHR AX,1
                MOV BX,AX
                MOV AX,x
                AND AX,7
                MOV CL,AL
                MOV AX,128
                ROR AX,CL

                MOV CX,347
        P1:
                MOV DI,CX
                SHL DI,1
                MOV DI,PlotBuffer[DI]
                ADD DI,BX
                XOR ES:[DI],AL
                LOOP P1
    END;
END yline;

PROCEDURE Cursor(x,y:CARDINAL);
BEGIN
    ASM
                PUSH BP
                MOV BP,0B000H
                MOV ES,BP
                POP BP
    END;

    IF first=TRUE THEN
        first:=FALSE;
        xline(y);
        yline(x);
        yloesch:=y;
        xloesch:=x;
    ELSE
        IF y # yloesch THEN
            WaitForVerticalRetrace;
            xline(yloesch);
            xline(y);
            yloesch:=y;
        END;
        IF x # xloesch THEN
            WaitForVerticalRetrace;
            yline(x);
            yline(xloesch);
            xloesch:=x;
        END;
    END;
END Cursor;

PROCEDURE MoveAbs(x,y:CARDINAL);
BEGIN
IF (x<720) AND (y<348) THEN                 (* in den richtigen Grenzen *)
    xalt:=x;                                (* dann setzen *)
    yalt:=y;
END;
END MoveAbs;

PROCEDURE MoveRel(xrelativ,yrelativ:INTEGER;
                      VAR ok:BOOLEAN);
VAR
    xtest,ytest:INTEGER;
BEGIN
ok:=FALSE;
xtest:=xalt;ytest:=yalt;                    (* CARDINAL nach INTEGER *)
xtest:=xtest+xrelativ;ytest:=ytest+yrelativ;
IF (xtest<0) OR (xtest>719) OR (ytest<0) OR (ytest>347) THEN RETURN;END;
ok:=TRUE;
xalt:=xtest;yalt:=ytest;
END MoveRel;

PROCEDURE DrawToAbs(x,y:CARDINAL);
BEGIN
    IF (x<720) AND (y<348) THEN
        Line(xalt,x,yalt,y);
    END;
END DrawToAbs;

PROCEDURE DrawToRel(xrelativ,yrelativ:INTEGER);
VAR ok:BOOLEAN;
VAR xtest,ytest:INTEGER;
BEGIN
ok:=FALSE;
xtest:=xalt;ytest:=yalt;                            (* CARDINAL nach INTEGER *)
xtest:=xtest+xrelativ;ytest:=ytest+yrelativ;
IF (xtest<0) OR (xtest>719) OR (ytest<0) OR (ytest>347) THEN RETURN;END;
ok:=TRUE;
Line(xalt,xtest,yalt,ytest);
END DrawToRel;

PROCEDURE DrawAbs(x,y:CARDINAL);
BEGIN
    IF (x<720) AND (y<347) THEN
        Line(xalt,x,yalt,y);
        xalt:=x;
        yalt:=y;
    END;
END DrawAbs;

PROCEDURE DrawRel(xrelativ,yrelativ:INTEGER;VAR ok:BOOLEAN);
VAR
    xtest,ytest:INTEGER;
BEGIN
ok:=FALSE;
xtest:=xalt;ytest:=yalt;                            (* CARDINAL nach INTEGER *)
xtest:=xtest+xrelativ;ytest:=ytest+yrelativ;
IF (xtest<0) OR (xtest>719) OR (ytest<0) OR (ytest>347) THEN RETURN;END;
ok:=TRUE;
Line(xalt,xtest,yalt,ytest);
xalt:=xtest;yalt:=ytest;
END DrawRel;

END Work.
